library
  Keydll;
{creates a special message to an application to process keyboardmessages even
 when the application does not have focus.
 This can only be done here, because hooks can only be handled in a DLL}
uses
  WinTypes, WinProcs;

const
  KeyboardHook     : thandle = 0;
  SaveExit         : Pointer = nil;
  TagTask          : word = 0;      {task to which the message should be sent to}
  messagenumber    : word = 0;      {messagenumber. Should be higher than wm_user}

function KeyboardProc(code : integer; wpar : word; lpar : longint): longint; export;
{this is the function that will be called when a key is pressed}
begin
	if code < 0 then {do not handle the message yourself}
  begin
    result := CallNextHookEx(KeyboardHook, code, wPar, lPar);
    exit;
  end;

  {optionally, some conditions can be met. e.g. only keydown, etc.}
  if TagTask <> 0 then {send a special message to the owning application}
    PostAppMessage(TagTask, MessageNumber, wPar, lPar);

	result := 0;
end;

procedure LibExit; far;
{automatically called when unloading the DLL, see exitproc := @libexit}
begin
  {restore the hook}
  UnhookWindowsHookEx(KeyboardHook);
  ExitProc := SaveExit;
end;

procedure settask(targettask : thandle; messageno : word); export;
{this function should be called to initialize the owning task and the messageno}
begin
	TagTask := targettask;
	MessageNumber := messageno;
end;

exports
  SetTask      index 1 name 'SETTASK',
  KeyboardProc index 2;

begin
  messagebox(0,'Shit!','keydll.dll',mb_iconinformation);
  {make sure that when the DLL is unloaded, the unhook-functions are executed}
  SaveExit := ExitProc;
  ExitProc := @LibExit;

  {install the routine that will handle the message}
  KeyboardHook := SetWindowsHookEx(WH_KEYBOARD, KeyboardProc, hInstance, 0)
end.





